routes/web.php
<?php

use App\Http\Controllers\Admin\CategoryController;
use App\Http\Controllers\Admin\CustomerController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\ProductController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\SliderController;
use App\Http\Controllers\Admin\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});
# admin
Route::controller(DashboardController::class)->group(function() {
    Route::get('/admin/dashboard', 'index')->name('admin.dashboard.index');
});
# admin / categories
Route::resource('/admin/categories', CategoryController::class, ['as' => 'admin']);

# admin / products
Route::resource('/admin/products', ProductController::class, ['as' => 'admin']);

# admin / orders
// Route::resource('/admin/orders', OrderController::class, ['only' => ['index', 'show'], 'as' => 'admin']);
Route::get('/admin/orders', [OrderController::class, 'index'])->name('admin.orders.index');
Route::get('/admin/orders/{invoice}', [OrderController::class, 'show'])->name('admin.orders.show');

# admin / customers
Route::get('/admin/customers', [CustomerController::class, 'index'])->name('admin.customers.index');

# admin / sliders
Route::resource('/admin/sliders', SliderController::class, ['only' => ['index', 'store', 'destroy'], 'as' => 'admin']);

# admin / profile
Route::get('/admin/profile', [ProfileController::class, 'index'])->name('admin.profile.index');

# admin / users
Route::resource('/admin/users', UserController::class, ['as' => 'admin']);

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;

    # fillable
    protected $fillable = [
        'name', 'slug', 'image',
    ];

    # relation table
    public function products()
    {
        return $this->hasMany(Product::class);
    }

    # route key name
    public function getRouteKeyName()
    {
        return 'slug';
    }


    protected function image(): Attribute
    {
        return Attribute::make(
            get: fn ($value) => asset('/storage/categories/img/' . $value),
        );
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Category;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\Rule;

class CategoryController extends Controller
{
    public function __construct()
    {
        $this->middleware(['auth', 'preventBackHistory']);
    }

    # get all data categories
    public function index()
    {
        # action get all data categories
        $categories = Category::latest()->when(request()->q, function ($categories) {
            $categories = $categories->where('name', 'like', '%' . request()->q . '%');
        })->paginate(15);

        # return view
        return view('admin.categories.index', compact('categories'));
    }

    # view create category
    public function create()
    {
        $category = new Category();
        return view('admin.categories.create', compact('category'));
    }

    # process create category
    public function store(Request $request)
    {
        # validation
        $request->validate([
            'image' => ['required', 'image', 'mimes:jpg,jpeg,png', 'max:2048'],
            'name' => ['required', 'min:3', 'max:150', Rule::unique('categories', 'name')],
        ]);

        # upload image handle
        $image = $request->file('image');
        $image->storeAs('categories/img', $image->hashName());

        # action create category
        Category::create([
            'image' => $image->hashName(),
            'name' => $request->name,
            'slug' => str($request->name)->slug()
        ]);

        # redirect
        return to_route('admin.categories.index')->with('success', 'Data category has been created');
    }

    public function show(Category $category)
    {
    }

    # view edit category
    public function edit(Category $category)
    {
        return view('admin.categories.edit', compact('category'));
    }

    # process update category
    public function update(Request $request, Category $category)
    {
        # validation
        $request->validate([
            'image' => ['nullable', 'image', 'mimes:jpg,jpeg,png', 'max:2048'],
            'name' => ['required', 'min:3', 'max:150', Rule::unique('categories', 'name')->ignore($category)],
        ]);

        # action update category
        if($request->file('image') == '')
        {
            $category->update([
                'name' => $request->name,
                'slug' => str($request->name)->slug()
            ]);
        } else {
            $image = $request->file('image');
            Storage::disk('public')->delete('categories/img/' . basename($category->image));
            $image->storeAs('categories/img', $image->hashName());

            $category->update([
                'image' => $image->hashName(),
                'name' => $request->name,
                'slug' => str($request->name)->slug()
            ]);
        }

        # redirect
        return to_route('admin.categories.index')->with('success', 'Data category has been updated');
    }

    # process delete category
    public function destroy(Category $category)
    {
        # delete category image
        Storage::disk('public')->delete('categories/img/' . basename($category->image));

        # action delete category
        $category = $category->delete();

        if ($category) {
            return response()->json([
                'status' => 'success'
            ]);
        }
    }
}

app/Http/Controllers/Api/CategoryController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Category;

class CategoryController extends Controller
{
    # get all data categories
    public function index()
    {
        # action get all data categories
        $categories = Category::latest()->get();

        # return response
        return response()->json([
            'success' => true,
            'message' => 'List Data Categories',
            'categories' => $categories,
        ]);
    }

    # get 5 data categories
    public function getFiveCategories()
    {
        # action get 5 data categories
        $categories = Category::latest()->take(5)->get();

        # return response
        return response()->json([
            'success' => true,
            'message' => 'List Data Categoresi',
            'categories' => $categories,
        ], 200);
    }

    # get product by category
    public function show(Category $category)
    {
        if ($category) {
            # if success get data category
            return response()->json([
                'success' => true,
                'message' => 'List Product by Category: ' . $category->name,
                'product' => $category->products()->latest()->get(),
            ], 200);
        } else {
            # if failed get data category
            return response()->json([
                'success' => false,
                'message' => 'Data Product By Category Not Found',
            ], 404);
        }
    }

    # get some categories for header
    public function categoryHeader()
    {
        # get 5 categories for header
        $categories = Category::latest()->take(5)->get();

        # return response
        return response()->json([
            'success' => true,
            'message' => 'List Data Category Header',
            'categories' => $categories,
        ]);
    }
}

resources/views/admin/categories/create.blade.php
@extends('layouts.app', ['title' => 'Add Category - GreenK Online Shop'])
@section('content')
<div class="container-fluid mb-5">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-folder mr-2"></i> Add Category</h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          {{-- form create category --}}
          <form action="{{ route('admin.categories.store') }}" method="POST" enctype="multipart/form-data">
            @include('admin.categories.form', ['submit' => 'Save'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/categories/edit.blade.php
@extends('layouts.app', ['title' => 'Edit Category - GreenK Online Shop'])
@section('content')
<div class="container-fluid">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold"><i class="fas fa-folder mr-2"></i> Edit Category</h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          {{-- form create category --}}
          <form action="{{ route('admin.categories.update', $category) }}" method="POST" enctype="multipart/form-data">
            @method('PUT')
            @include('admin.categories.form', ['submit' => 'Update'])
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@endsection

resources/views/admin/categories/form.blade.php
  @csrf
  {{-- image --}}
  <div class="form-group">
    <label for="image" class="form-label">Image</label>
    <input type="file" name="image" class="form-control @error('image') is-invalid @enderror" id="image" accept="image/*">
    @error('image')
    <div class="invalid-feedback">
      <strong>{{ $message }}</strong>
    </div>
    @enderror
  </div>

  {{-- category name --}}
  <div class="form-group">
    <label for="name" class="form-label">Category Name</label>
    <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" id="name" value="{{ old('name', $category->name) }}"
    placeholder="Category Name">
    @error('name')
    <div class="invalid-feedback">
      <strong>{{ $message }}</strong>
    </div>
    @enderror
  </div>

  {{-- button submit --}}
  <button type="submit" class="btn btn-primary mr-1 btn-submit"> {{ $submit }}</button>

resources/views/admin/categories/index.blade.php
@extends('layouts.app', ['title' => 'Categories - GreenK Online Shop'])
@section('content')
<div class="container-fluid mb-5">
  <div class="row">
    <div class="col-md-12">
      <div class="card border-0 shadow">
        {{-- card header --}}
        <div class="card-header">
          <h6 class="m-0 font-weight-bold">
            <i class="fas fa-folder mr-2"></i> Categories
          </h6>
        </div>
        {{-- card body --}}
        <div class="card-body">
          <form action="{{ route('admin.categories.index') }}" method="GET">
            <div class="row">
              <div class="col-md-4 mb-3 mb-md-0">
                <a href="{{ route('admin.categories.create') }}" class="btn btn-primary btn-md">
                  Add Category
                </a>
              </div>

              {{-- search categories --}}
              <div class="col-md-8">
                <div class="form-group">
                  <div class="input-group">
                    <input type="search" class="form-control form-control-md" name="q" placeholder="Search Categories...">
                    <div class="input-group-append">
                      <button type="submit" class="btn btn-primary"><i class="fa fa-search"></i></button>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </form>
          {{-- table of categories --}}
          <div class="table-responsive">
            <table class="table table-hover">
              <thead>
                <tr>
                  <th scope="col" style="text-align: center; width: 6%;">No.</th>
                  <th scope="col">Image</th>
                  <th scope="col">Category Name</th>
                  <th scope="col" style="text-align: center; width: 15%">Action</th>
                </tr>
              </thead>
              <tbody>
                @forelse ($categories as $category)
                <tr>
                  <td scope="row" class="text-center">
                    {{ $categories->firstItem() + $loop->index }}
                  </td>
                  <td scope="row" class="text-center">
                    <img src="{{ asset($category->image) }}" style="width: 50px">
                  </td>
                  <td scope="row">
                    {{ $category->name }}
                  </td>
                  <td scope="row" class="text-center">
                    <a href="{{ route('admin.categories.edit', $category) }}" class="btn btn-primary btn-sm mb-2 mb-md-0">
                      <i class="fa fa-pencil-alt"></i>
                    </a>
                    <button onclick="Delete(this.id)" class="btn btn-sm btn-danger" id="{{ $category->slug }}">
                      <i class="fa fa-trash"></i>
                    </button>
                  </td>
                </tr>
                @empty
                <tr>
                  <td scope="row" colspan="4">
                    <div class="text-danger text-center">No data categories.</div>
                  </td>
                </tr>
                @endforelse
              </tbody>
            </table>
            {{-- pagination --}}
            {{ $categories->links() }}
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<script>
  /* ajax delete */
  function Delete(id) {
    var id = id;
    var token = $("meta[name='csrf-token']").attr("content");

    Swal.fire({
      title: "Want to delete this data?"
      , text: "Data that has been deleted cannot be recovered"
      , icon: "warning"
      , showCancelButton: true
      , confirmButtonColor: '#3085d6'
      , cancelButtonColor: '#d33'
      , confirmButtonText: 'Yes, delete it!'
    }).then((result) => {
      if (result.isConfirmed) {
        jQuery.ajax({
          url: "/admin/categories/" + id
          , data: {
            "id": id
            , "_token": token
          }
          , type: "DELETE"
        });
        Swal.fire({
          position: 'center'
          , icon: 'success'
          , title: 'Data category has been deleted'
          , showConfirmButton: false
          , timer: 1500
        , }).then(function() {
          location.reload();
        });
      }
    });
  }
</script>
@endsection